--- oldmain.c	Sat May  5 20:18:06 2001
+++ newmain.c	Sat May  5 20:36:28 2001
@@ -5,6 +5,10 @@
 #include "resource.h"
 #include "encthread.h"
 
+/* Signed versions of LOWORD and HIWORD */
+#define LOSHORT(l)           ((SHORT)(l))
+#define HISHORT(l)           ((SHORT)(((DWORD)(l) >> 16) & 0xFFFF))
+
 HANDLE event = NULL;
 int width = 120, height = 120;
 RECT bar1, bar2;
@@ -202,8 +206,12 @@
 
 	case WM_MOUSEMOVE:
 		if (dragging) {
+			point.x = LOSHORT(lParam);
+			point.y = HISHORT(lParam);
+			/* lParam can contain negative coordinates !
 			point.x = LOWORD(lParam);
 			point.y = HIWORD(lParam);
+			*/
 			ClientToScreen(hwnd, &point);
 			SetWindowPos(hwnd, 0, point.x - start.x, point.y - start.y, 0, 0, SWP_NOSIZE | SWP_NOZORDER | SWP_SHOWWINDOW);
 		}

